import ctypes as ctypes
import time as xtime

#CAN 2.0 speed
##############################################
SPEED_10k     = 10
SPEED_20k     = 20
SPEED_33_3k   = 33
SPEED_50k     = 50
SPEED_62_5k   = 62
SPEED_83_3k   = 83
SPEED_100k    = 100
SPEED_125k    = 125
SPEED_250k    = 250
SPEED_500k    = 500
SPEED_1M      = 1000
SPEED_USR     = 0
#CAN FD speed
#################################################3
CAN_125K_250K = 125250
CAN_125K_500K = 125500
CAN_125K_833K = 125833
CAN_125K_1M   = 1251000
CAN_125K_1M5  = 1251500
CAN_125K_2M   = 1252000
CAN_125K_3M   = 1253000
CAN_125K_4M   = 1254000
CAN_125K_5M   = 1255000
CAN_125K_6M7  = 1256700
CAN_125K_8M   = 1258000
CAN_125K_10M  = 1259999
CAN_250K_500K = 250500
CAN_250K_833K = 250833
CAN_250K_1M   = 2501000
CAN_250K_1M5  = 2501500
CAN_250K_2M   = 2502000
CAN_250K_3M   = 2503000
CAN_250K_4M   = 2504000
CAN_250K_5M   = 2505000
CAN_250K_6M7  = 2506700
CAN_250K_8M   = 2508000
CAN_250K_10M  = 2509999
CAN_500K_833K = 500833
CAN_500K_1M   = 5001000
CAN_500K_1M5  = 5001500
CAN_500K_2M   = 5002000
CAN_500K_3M   = 5003000
CAN_500K_4M   = 5004000
CAN_500K_5M   = 5005000
CAN_500K_6M7  = 5006700
CAN_500K_8M   = 5008000
CAN_500K_10M  = 5009999
CAN_1000K_1M5 = 10001500
CAN_1000K_2M  = 10002000
CAN_1000K_3M  = 10003000
CAN_1000K_4M  = 10004000
CAN_1000K_5M  = 10005000
CAN_1000K_6M7 = 10006700
CAN_1000K_8M  = 10008000
CAN_1000K_10M = 10009999

###########################################################################################
#set path to desired location
DLL_PATH = "./x64/X2CAN_3th_dll_x64.dll"
###########################################################################################

class CANMessageTime(ctypes.Structure):
    """ creates a struct to match CANMessageTime """

    _fields_ = [('Hour', ctypes.c_ushort),
                ('Minute', ctypes.c_ushort),
                ('Second', ctypes.c_ushort),
                ('Milliseconds', ctypes.c_ushort),
                ('TimeStampUS', ctypes.c_ulong)]


class CAN_MESSAGE(ctypes.Structure):
    """ creates a struct to match CAN_MESSAGE """

    _fields_ = [('Id1', ctypes.c_int16),
                ('Id2', ctypes.c_int32),
                ('Id', ctypes.c_int32),
                ('length', ctypes.c_ubyte),
                ('rtr', ctypes.c_bool),
                ('st_ext', ctypes.c_bool),
                ('fd_can', ctypes.c_bool),
                ('fd_esi', ctypes.c_bool),
                ('fd_br_switch', ctypes.c_bool),
                ('fd_sid11', ctypes.c_bool),
                ('data', ctypes.c_ubyte*8),
                ('fd_data', ctypes.POINTER(ctypes.c_ubyte)),
                ('time', CANMessageTime),
                ('port', ctypes.c_uint32),
                ('dont_delete', ctypes.c_bool)]


usb2can_lib = ctypes.CDLL(DLL_PATH)

###############################################################################################
###############################################################################################
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapter.argtypes = [ctypes.c_int32]
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapter.restype = ctypes.POINTER(
    ctypes.c_void_p)

usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC1.argtypes = [ctypes.POINTER(ctypes.c_void_p),
                                                             ctypes.c_int32,
                                                             ctypes.c_bool]

usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC2.argtypes = [ctypes.POINTER(ctypes.c_void_p),
                                                             ctypes.c_int32,
                                                             ctypes.c_bool]
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC3.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_int32, ctypes.c_bool, ctypes.c_bool, ctypes.c_bool]

usb2can_lib.USB2CAN_TRIPLE_SelectActualAdapter.argtypes = [
    ctypes.POINTER(ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_SelectActualAdapter.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_SetTimeStampMode.argtypes = [ctypes.c_bool]
usb2can_lib.USB2CAN_TRIPLE_SetTimeStampMode.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_SetBufferMode.argtypes = [
    ctypes.c_int32]  # output pointer
usb2can_lib.USB2CAN_TRIPLE_SetBufferMode.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_Open.argtypes = [ctypes.c_int32,
                                            ctypes.POINTER(ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_Open.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage29.argtypes = [ctypes.c_int32,
                                                             ctypes.c_bool,
                                                             ctypes.c_ubyte,
                                                             ctypes.POINTER(ctypes.c_ubyte)]

usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage29.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_GetRXBufferLength.restype = ctypes.c_int32
usb2can_lib.USB2CAN_TRIPLE_GetCANMessage.argtypes = [
    ctypes.POINTER(ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_SendCANMessage.argtypes = [CAN_MESSAGE]

# usb2can_lib.USB2CAN_TRIPLE_SetUsrNominalBitTime(unsigned int NBRP, unsigned int NTSEG1, unsigned int NTSEG2,unsigned int NSJW);
usb2can_lib.USB2CAN_TRIPLE_SetUsrNominalBitTime.argtypes = [
    ctypes.c_int, ctypes.c_int, ctypes.c_int, ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_SetUsrDataBitTime.argtypes = [
    ctypes.c_uint32, ctypes.c_uint32, ctypes.c_uint32, ctypes.c_uint32, ctypes.c_uint32, ctypes.c_uint32, ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_DestroyAdapter.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]

usb2can_lib.USB2CAN_TRIPLE_SelectActualAdapterAccess.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]

usb2can_lib.USB2CAN_TRIPLE_OpenSimple.argtypes =[ ctypes.c_int32]
usb2can_lib.USB2CAN_TRIPLE_OpenSimple.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_Close.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_Reset.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_SendRegisterMessage.argtypes = [ctypes.POINTER(
    ctypes.c_ubyte)]
usb2can_lib.USB2CAN_TRIPLE_SendRegisterMessage.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendStandardMessage.argtypes = [
    ctypes.c_int16, ctypes.c_bool, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.USB2CAN_TRIPLE_SendStandardMessage.restype = ctypes.c_bool
# usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage(unsigned __int16 StandardId, unsigned __int32 ExtendedId, bool RTR, unsigned char Length, unsigned char *Data);
usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage.argtypes = [
    ctypes.c_int16, ctypes.c_int32, ctypes.c_bool, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage.restype = ctypes.c_bool
# usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage29(unsigned __int32 ExtendedId, bool RTR, unsigned char Length, ctypes.POINTER(ctypes.c_ubyte));
usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage.argtypes = [
    ctypes.c_int16, ctypes.c_int32, ctypes.c_bool, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]

usb2can_lib.USB2CAN_TRIPLE_SendExtendedMessage29.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_SendCANMessageP.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_SendCANMessageP.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendCANMessage2.argtypes = [
    ctypes.POINTER(ctypes.c_void_p), ctypes.POINTER(ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_SendCANMessage2.restype = ctypes.c_bool

# usb2can_lib.USB2CAN_TRIPLE_GetMessage11_18(bool *StExt, unsigned __int16 *StandardId, unsigned __int32 *ExtendedId, bool *RTR, unsigned char *Length, unsigned char *Data);
usb2can_lib.USB2CAN_TRIPLE_GetMessage11_18.argtypes = [ctypes.POINTER(ctypes.c_bool), ctypes.POINTER(
    ctypes.c_uint16), ctypes.POINTER(ctypes.c_uint32), ctypes.POINTER(ctypes.c_bool), ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.USB2CAN_TRIPLE_GetMessage11_18.restype = ctypes.c_bool
# usb2can_lib.USB2CAN_TRIPLE_GetMessage29(bool *StExt, unsigned __int32 *Id, bool *RTR, unsigned char *Length, unsigned char *Data);
usb2can_lib.USB2CAN_TRIPLE_GetMessage29.argtypes = [ctypes.POINTER(ctypes.c_bool), ctypes.POINTER(
    ctypes.c_uint32), ctypes.POINTER(ctypes.c_bool), ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.USB2CAN_TRIPLE_GetMessage29.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_GetCANMessage.restype = ctypes.c_bool

#usb2can_lib.USB2CAN_TRIPLE_GetCANTXMessage.argtypes = ctypes.POINTER(CAN_MESSAGE)
usb2can_lib.USB2CAN_TRIPLE_GetCANTXMessage.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.USB2CAN_TRIPLE_SendCANMessage2.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_SetTimeStampMode.argtypes = [ctypes.c_bool]

usb2can_lib.USB2CAN_TRIPLE_GetRXBufferLength.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_GetTXBufferLength.restype = ctypes.c_int
# usb2can_lib.USB2CAN_TRIPLE_GetTXBufferLengthByPort(const unsigned port);
usb2can_lib.USB2CAN_TRIPLE_GetTXBufferLengthByPort.argtypes = [ctypes.c_uint]
usb2can_lib.USB2CAN_TRIPLE_GetTXBufferLengthByPort.restype = ctypes.c_int
# usb2can_lib.USB2CAN_TRIPLE_WaitForRxMessage(const unsigned int timeout);
usb2can_lib.USB2CAN_TRIPLE_WaitForRxMessage.argtypes = [ctypes.c_uint]
usb2can_lib.USB2CAN_TRIPLE_WaitForRxMessage.restype = ctypes.c_bool
# usb2can_lib.USB2CAN_TRIPLE_WaitForTxMessage(const unsigned int timeout);
usb2can_lib.USB2CAN_TRIPLE_WaitForTxMessage.argtypes = [ctypes.c_uint]
usb2can_lib.USB2CAN_TRIPLE_WaitForTxMessage.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_GetREC.restype = ctypes.c_ubyte
usb2can_lib.USB2CAN_TRIPLE_GetTEC.restype = ctypes.c_ubyte
usb2can_lib.USB2CAN_TRIPLE_GetRST.restype = ctypes.c_int

usb2can_lib.USB2CAN_TRIPLE_GetTECByPort.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_GetTECByPort.restype = ctypes.c_ubyte
usb2can_lib.USB2CAN_TRIPLE_GetRECByPort.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_GetRECByPort.restype = ctypes.c_ubyte

usb2can_lib.USB2CAN_TRIPLE_GetFWVersion.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_GetFWVersionNumber.restype = ctypes.c_uint

usb2can_lib.USB2CAN_TRIPLE_SetBufferMode.argtypes = [ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_SendBufferMode.restype = ctypes.c_bool

# Command
usb2can_lib.USB2CAN_TRIPLE_SendGetBufferMode.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendSerNum.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendGetSerNum.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_SendGetSerNum.restype = ctypes.POINTER(
    ctypes.c_byte)

usb2can_lib.USB2CAN_TRIPLE_IsFDCANSupported.restype = ctypes.c_int32

usb2can_lib.USB2CAN_TRIPLE_ForwardPort2.argtypes = [
    ctypes.c_bool, ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_ForwardPort2.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_ForwardPort3.argtypes = [
    ctypes.c_bool, ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_ForwardPort3.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_IsForwardPort2Enabled.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_IsForwardPort3Enabled.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_GetForwardPort2Number.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_GetForwardPort2Number.restype = ctypes.c_int

usb2can_lib.USB2CAN_TRIPLE_SetBusLoadLimitC1.argtypes = [ctypes.c_double]
usb2can_lib.USB2CAN_TRIPLE_GetBusLoadLimitC1.restype = ctypes.c_double

usb2can_lib.USB2CAN_TRIPLE_SetBusLoadLimitC2.argtypes = [ctypes.c_double]
usb2can_lib.USB2CAN_TRIPLE_GetBusLoadLimitC2.restype = ctypes.c_double

usb2can_lib.USB2CAN_TRIPLE_SetBusLoadLimitC3.argtypes = [ctypes.c_double]
usb2can_lib.USB2CAN_TRIPLE_GetBusLoadLimitC3.restype = ctypes.c_double

usb2can_lib.USB2CAN_COMBO_GetFaultInjectorMode.restype = ctypes.c_bool
usb2can_lib.USB2CAN_COMBO_GetFaultInjectorModeActive.restype = ctypes.c_bool


usb2can_lib.USB2CAN_COMBO_SingleWireMode.argtypes = [ctypes.c_bool]
usb2can_lib.USB2CAN_COMBO_SingleWireMode.restype = ctypes.c_bool
usb2can_lib.USB2CAN_COMBO_GetLowSpeedError.restype = ctypes.c_bool
usb2can_lib.USB2CAN_COMBO_SingleWireHighSpeedFeedback.restype = ctypes.c_bool


usb2can_lib.USB2CAN_TRIPLE_SetFaultInjectionMode.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_FaultInject.argtypes = [
    ctypes.c_uint32, ctypes.c_uint8, ctypes.c_uint8]
usb2can_lib.USB2CAN_TRIPLE_FaultInject.restype = ctypes.c_bool

# index - index of the sending buffer 0..15
# message - message that is sent periodically
# time - message generation period with 100us resolution
# flags - enable, dblbuf, togle bit, definition in file usb2xxx_gen2.h
# checksum_mode - type of automatic checksum,  definition in file usb2xxx_gen2.h
# bit - position of toggle bit
# X2CAN_DLLMAPPING bool USB2CAN_TRIPLE_HWSync_Write(int index, CAN_MESSAGE message, unsigned __int16 time, unsigned __int8 flags);
usb2can_lib.USB2CAN_TRIPLE_HWSync_Write.argtypes = [
    ctypes.c_int, CAN_MESSAGE, ctypes.c_uint16, ctypes.c_uint8]
usb2can_lib.USB2CAN_TRIPLE_HWSync_Write.restype = ctypes.c_bool
# X2CAN_DLLMAPPING bool USB2CAN_TRIPLE_HWSync_WriteWithChecksum(int index, CAN_MESSAGE message, unsigned __int16 time, unsigned __int8 flags, unsigned __int8 checksum_mode);
usb2can_lib.USB2CAN_TRIPLE_HWSync_WriteWithChecksum.argtypes = [
    ctypes.c_int, CAN_MESSAGE, ctypes.c_uint16, ctypes.c_uint8, ctypes.c_uint8]
usb2can_lib.USB2CAN_TRIPLE_HWSync_WriteWithChecksum.restype = ctypes.c_bool
# X2CAN_DLLMAPPING bool USB2CAN_TRIPLE_HWSync_WriteWithToggleBit(int index, CAN_MESSAGE message, unsigned __int16 time, unsigned __int8 flags, unsigned __int8 checksum_mode, unsigned __int8 bit);
usb2can_lib.USB2CAN_TRIPLE_HWSync_WriteWithToggleBit.argtypes = [
    ctypes.c_int, CAN_MESSAGE, ctypes.c_uint16, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_uint8]
usb2can_lib.USB2CAN_TRIPLE_HWSync_WriteWithToggleBit.restype = ctypes.c_bool

# reads the specified buffer from the converter and stores the data in the internal API structure. The individual items of the buffer structure can then be read using the Get functions.
usb2can_lib.USB2CAN_TRIPLE_HWSync_Read.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_Read.restype = ctypes.c_bool

# index -index of the sending buffer (0.15) that is enabled or disabled
usb2can_lib.USB2CAN_TRIPLE_HWSync_Enable.restype = ctypes.c_int
usb2can_lib.USB2CAN_TRIPLE_HWSync_Enable.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_HWSync_Disable.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_Disable.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_HWSync_GetMessage.argtypes = [
    ctypes.c_int, CAN_MESSAGE]
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetMessage.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetPeriode.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetPeriode.restype = ctypes.c_uint
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetFlags.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetFlags.restype = ctypes.c_uint
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetChecksumMode.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetChecksumMode.restype = ctypes.c_uint
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetToggleBit.argtypes = [ctypes.c_int]
usb2can_lib.USB2CAN_TRIPLE_HWSync_GetToggleBit.restype = ctypes.c_uint

# enables or disables the generation of messages from buffers at once using the mask
usb2can_lib.USB2CAN_TRIPLE_HWSync_DisableByMask.argtypes = [ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_HWSync_DisableByMask.restype = ctypes.c_bool
usb2can_lib.USB2CAN_TRIPLE_HWSync_EnableByMask.argtypes = [ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_HWSync_EnableByMask.restype = ctypes.c_bool

# Sets the HW gatewaye item. For this function, the port and the st_ext flag are part of the identifier. It is recommended to use the USB2CAN_TRIPLE_GWSetItem function .
usb2can_lib.USB2CAN_TRIPLE_GWSetItem2.argtypes = [
    ctypes.c_int, ctypes.c_uint32,  ctypes.c_uint32]
usb2can_lib.USB2CAN_TRIPLE_GWSetItem2.restype = ctypes.c_bool
# The identifier and mask are used to determine if the message is a forwarded message. The mask is applied to both the specified
# item identifier and the received message identifier. If the results match, the message is forwarded.
usb2can_lib.USB2CAN_TRIPLE_GWSetItem.argtypes = [
    ctypes.c_int, ctypes.c_uint32,  ctypes.c_uint32, ctypes.c_bool, ctypes.c_uint]
usb2can_lib.USB2CAN_TRIPLE_GWSetItem.restype = ctypes.c_bool

# size - gateway table size (number of items)
# mode1/mode2 - forwarding mode 0-forward all. forward messages from a table, 2-dont forward messages from a table
usb2can_lib.USB2CAN_TRIPLE_GWSetTableSize.argtypes = [
    ctypes.c_uint8, ctypes.c_uint8, ctypes.c_uint8, ctypes.c_uint8]
usb2can_lib.USB2CAN_TRIPLE_GWSetTableSize.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_CheckUSB2CAN.restype = ctypes.c_bool

usb2can_lib.USB2CAN_TRIPLE_FindCOM.argtypes = [ctypes.c_bool]
usb2can_lib.USB2CAN_TRIPLE_FindCOM.restype = ctypes.c_int
###############################################################################################
###############################################################################################
usb2can_lib.X2CAN_PrepareMessage.restype = ctypes.POINTER(ctypes.c_void_p)

# Nastaveni dat ze zadaneho pole, jako delka je pouzita hodnota ulozena ve zprave
usb2can_lib.X2CAN_SetData.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.X2CAN_SetData.restype = ctypes.c_bool
# Nastaveni dat ze zadaneho pole, jako delka je pouzita hodnota parametru Length
usb2can_lib.X2CAN_SetDataAndLength.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
usb2can_lib.X2CAN_SetDataAndLength.restype = ctypes.c_bool
# Individualni nastaveni datoveho bajtu, vraci false pokud je index mimo rozah nebo je zadan index FD dat a zprava neni nastavena jako FD - nema alokovanou pamet
usb2can_lib.X2CAN_SetDataByte.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_ubyte, ctypes.c_ubyte]
usb2can_lib.X2CAN_SetDataByte.restype = ctypes.c_bool
# Nataveni priznaku Baud rate switch
usb2can_lib.X2CAN_SetBRS.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_bool]
usb2can_lib.X2CAN_SetBRS.restype = ctypes.c_bool
# Nastaveni priznaku FD zpravy - nealokuje ale pamet pro FD data
usb2can_lib.X2CAN_SetFD.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_bool]
usb2can_lib.X2CAN_SetFD.restype = ctypes.c_bool
# Nastaveni delky - nealokuje ale pamet pro FD data
usb2can_lib.X2CAN_SetLength.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_ubyte]
usb2can_lib.X2CAN_SetLength.restype = ctypes.c_bool
# Nataveni priznaku RTR
usb2can_lib.X2CAN_SetRTR.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_bool]
usb2can_lib.X2CAN_SetRTR.restype = ctypes.c_bool
usb2can_lib.X2CAN_SetSID11.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_bool]
usb2can_lib.X2CAN_SetSID11.restype = ctypes.c_bool
# Nastaveni cisla CAN portu u prevodniku s vice porty
usb2can_lib.X2CAN_SetPort.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_uint32]
usb2can_lib.X2CAN_SetPort.restype = ctypes.c_bool

# Vraci hodnotu identifikatoru
usb2can_lib.X2CAN_GetStandardId.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_SetPort.restype = ctypes.c_uint32
usb2can_lib.X2CAN_GetExtendedId.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_SetPort.restype = ctypes.c_uint32
usb2can_lib.X2CAN_GetExtendedId29.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_SetPort.restype = ctypes.c_uint32

# Test RTR flag
usb2can_lib.X2CAN_IsRTR.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_IsRTR.restype = ctypes.c_bool
# Test flag - 29b Id
usb2can_lib.X2CAN_IsExt.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_IsExt.restype = ctypes.c_bool
# Test CAN FD zpr8va
usb2can_lib.X2CAN_IsFD.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_IsFD.restype = ctypes.c_bool
# Test Baud rate switch
usb2can_lib.X2CAN_GetBRS.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetBRS.restype = ctypes.c_bool
usb2can_lib.X2CAN_GetSID11.argtypes =[ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetSID11.restype = ctypes.c_bool
# Vraci port
usb2can_lib.X2CAN_GetPort.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
# Vraci zadany datovy bajt, pokud je napriklad index mimo rozsah, nebo delku zpravy, vraci 0x00
usb2can_lib.X2CAN_GetData.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.c_uint8]
usb2can_lib.X2CAN_GetData.restype = ctypes.c_uint8
# Vraci delku zpravy
usb2can_lib.X2CAN_GetLength.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]

usb2can_lib.X2CAN_GetLength.restype = ctypes.c_uint8
# Precteni dat z CAN zpravy - 8 datovych bajtu, vraci pocet prectenych bajtu
usb2can_lib.X2CAN_GetDataClassic.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.POINTER(ctypes.c_uint8)]
usb2can_lib.X2CAN_GetDataClassic.restype = ctypes.c_uint8
# Precteni dat z CAN FD zpravy - az 56 dalsich datovych bajtu, vraci pocet prectenych bajtu
usb2can_lib.X2CAN_GetDataFD.argtypes = [ctypes.POINTER(
    ctypes.c_void_p), ctypes.POINTER(ctypes.c_uint8)]
usb2can_lib.X2CAN_GetDataFD.restype = ctypes.c_uint8

# Cteni polozek casove znacky
# Pokud vraci FFFFFFFF - Message je neplatne (NULL)
usb2can_lib.X2CAN_GetHour.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetHour.restype = ctypes.c_uint32

usb2can_lib.X2CAN_GetMinute.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetMinute.restype = ctypes.c_uint32
usb2can_lib.X2CAN_GetSecond.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetSecond.restype = ctypes.c_uint32
usb2can_lib.X2CAN_GetMilliseconds.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetMilliseconds.restype = ctypes.c_uint32
usb2can_lib.X2CAN_GetTimestamp.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
usb2can_lib.X2CAN_GetTimestamp.restype = ctypes.c_uint32

# Dealokace pameti zpravy
usb2can_lib.X2CAN_DestroyMessage.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]

# Dealokuje buffer pro FD data
usb2can_lib.X2CAN_DeleteFDBuffer.argtypes = [ctypes.POINTER(
    ctypes.c_void_p)]
